import os
from utility import pypyodbc
from qgis.core import *
from qgis.gui import *

def getIndagini(tipo,project_path):
	if u'Microsoft Access Driver (*.mdb)' in pypyodbc.drivers():
		driver = u'Microsoft Access Driver (*.mdb)'
	if u'Microsoft Access Driver (*.mdb, *.accdb)' in pypyodbc.drivers():
		driver = u'Microsoft Access Driver (*.mdb, *.accdb)'
	#mdb = os.path.join(os.path.split(os.getcwd())[0], "Indagini", "CdI_Tabelle.mdb")
	initial_path = os.path.dirname(project_path)
	mdb = os.path.join(initial_path,'..','..', "Indagini", "CdI_Tabelle.mdb")
	passwd = "Chaira"
	connStr = "DRIVER=%s;DBQ=%s;PWD=%s" % (driver, mdb, passwd)

	connection = pypyodbc.connect(connStr)
	cursor = connection.cursor()
	if tipo.lower() == 'puntuale':
		sqlString = """ SELECT Sito_Puntuale.ID_SPU, Indagini_Puntuali.tipo_ind
				FROM Sito_Puntuale, Indagini_Puntuali WHERE	 Sito_Puntuale.pkey_spu = Indagini_Puntuali.pkey_spu; """
	else:
		sqlString = """ SELECT Sito_Lineare.ID_SLN, Indagini_Lineari.tipo_ind
				FROM Sito_Lineare, Indagini_Lineari WHERE  Sito_Lineare.pkey_sln = Indagini_Lineari.pkey_sln; """
	cursor.execute(sqlString)
	return cursor.fetchall()


def getIndData(tipo):
	layer = QgsVectorLayer( os.path.join('..','..', "Indagini", "Ind_{}.shp".format("pu" if tipo == 'puntuale' else "ln")), 'layer', 'ogr')
	features = layer.getFeatures()
	return [(feature['ID_S{}'.format("PU" if tipo == 'puntuale' else "LN")], QgsGeometry (feature.geometry())) for feature in features]

def combineLayers(tipo,project_path):
	dataList = getIndagini(tipo,project_path)
	geometryList = getIndData(tipo)
	layerList = []
	for data in dataList:
		ID_SPU, tipo_ind = data
		for geometry in geometryList:
			ID_SPU_geom, geom = geometry
			if ID_SPU == ID_SPU_geom:
				layerList.append((ID_SPU,tipo_ind,geom))
	return layerList


def createLayer(nome, tipo,project_path):
	#layer = QgsVectorLayer('{}?crs=epsg:32633&field=ID_SPU:string&field=tipo_ind:string&index=yes'.format("Point" if tipo == 'puntuale' else "Linestring"), nome,'memory')
	#layer = QgsVectorLayer('Point?crs=epsg:32633&field=ID_SPU:string&field=tipo_ind:string&index=yes', 'nome','memory')
	layer= QgsMapLayerRegistry.instance().mapLayersByName('{}'.format("Ind_pu" if tipo == 'puntuale' else "Ind_ln"))[0]
	with edit(layer):
		listOfIds = [feat.id() for feat in layer.getFeatures()]
		layer.deleteFeatures( listOfIds )
	layerList = combineLayers(tipo,project_path)
	pr = layer.dataProvider()
	for element in layerList:
		ID_SPU,tipo_ind,geom = element
		ft = QgsFeature()
		ft.setAttributes([ID_SPU,tipo_ind])
		ft.setGeometry(geom)
		pr.addFeatures([ft])
	layer.updateExtents()
	return layer


def main(project_path):	
	layer_pu = createLayer('Ind_pu','puntuale',project_path)
	#QgsMapLayerRegistry.instance().addMapLayer(layer_pu)
	#layer_pu.loadNamedStyle(os.path.join('Stili','Ind_pu_rev02.qml'))
	#layer_pu.triggerRepaint()
	#renderer = QgsPointDisplacementRenderer()
	#layer_pu.setRendererV2(renderer)
	layer_pu.triggerRepaint()
	layer_ln = createLayer('Ind_ln','lineare',project_path)
	layer_ln.triggerRepaint()




